/****************************************************************************/
/* header file for m4                                                       */
/****************************************************************************/

#define EVALSIZE        32768U
#define MAXTOKEN        512
#define ARGSIZE         128
#define CALLSIZE        128
#define IBUFSIZ         32768U
#define ISTSIZE         8
#define AQUOTSZ         4
#define HASHSIZE        251

typedef enum   { StringType, DefType, IfType, IncrType, DecrType, SubType,
                 EvType, ChqType, UndType, IfdType, InclType, SinclType,
                 DivType, UndivType, DivnType, LenType, IndType, TransType,
                 ErrType, DumpType, DnlType, ChargType, AquoType,
                 NobuiltType, CmntType, MacType, MktmpType, SyscmdType,
                 GetenvType, IgnorenlType, PrintfType, NuloutType, CharType,
                 SwapcmdType, OutputType, RedefType, TraceType, UntraceType,
                 TracefileType, ParenType, CommaType
               } MacroType;

#define COMMA           ','
#define LPAREN          '('
#define RPAREN          ')'
#define LQUOTE          '`'
#define RQUOTE          '\''
#define EOS             '\0'
#define ARGFLAG         '$'
#define COMMENT         '#'

#define WORD            'w'

#ifndef TRUE
#define TRUE            1
#endif
#ifndef FALSE
#define FALSE           0
#endif

#if defined(__TURBOC__) && !defined(_MAX_PATH)
#define _MAX_PATH       MAXPATH
#endif

struct defentry {       MacroType           type;
                        unsigned char       trace;
                        char                *name;
                        char                *def;
                        struct defentry     *next;
                        struct defentry     *hnext;
                };

struct callstack {      MacroType           type;
                        unsigned char       trace;
                        char                **args;
                        unsigned            plev;
                 };

struct istack {         FILE        *ifile;
                        char        *ip;
              };

extern int              lquote, rquote, lparen, rparen, comma,
                        comment, macchr, nulout;
extern char             aquotes[];
extern int              ignorenl;
extern char             *pgmname;
extern char             nullstr[];
extern FILE             *outfile[];
extern FILE             *tracefile;
extern int              curout;
extern struct istack    istk[];
extern struct istack    *isp;


void                    dodef(char **afrom, char **ato);
void                    doif(char **afrom, char **ato);
void                    doincr(char *num, int i);
void                    dosub(char **afrom, char **ato);
void                    dochq(char **afrom, char **ato);
void                    doparen(char **afrom);
void                    docomma(char **afrom);
void                    doaquot(char **afrom, char **ato);
void                    dodnl(void);
void                    domktmp(char *s);
void                    dogetenv(char *s);
void                    doignorenl(char *s);
void                    dosyscmd(char *s);
void                    doswapcmd(char *s);
void                    dochar(char **afrom, char **ato);
void                    doifdef(char **afrom, char **ato);
void                    doindex(char **afrom, char **ato);
void                    dotrans(char **afrom, char **ato);
void                    doundef(char *name);
void                    donobuilt(void);
void                    doincl(char *name, int quiet);
void                    dodiv(char **divno);
void                    doundiv(char **afrom, char **ato);
void                    undivall(void);
void                    dodump(char **afrom, char **ato);
void                    setoutput(char *fname, char *append,
                                  char *curname, FILE **f);
void                    dotrace(char **afrom, char **ato);
void                    dountrace(char **afrom, char **ato);
void                    install(char *name, char *defn, unsigned type);

void                    doeval(char *expr);

int                     gettoken(char *token, int toksize);
void                    puttoken(char *s);
void                    putchr(int c);
void                    push(void);
void                    pbnum(long n);
struct defentry         *lookup(char *name);
void                    putbak(int c);
int                     ngetc(void);
int                     nextfile(void);
int                     newin(char *name, int quiet);
void                    pbstr(char *s);
void                    error(char *f, ...);
